// Alien Crime Lord
local GameTick = 0

if not rawget(_G, "_Gem") then
	rawset(_G, "_Gem", {})
end

_Gem.Max_Energy = 750
_Gem.Recharge_Rate = 6
_Gem.Binds = {
	["NextWeapon"] = BT_WEAPONNEXT;
	["WeaponPrev"] = BT_WEAPONPREV;
	["Fire"] = BT_ATTACK;
	["CamLeft"] = BT_CAMLEFT;
	["CamRight"] = BT_CAMRIGHT;
	["CamLeft"] = BT_CAMLEFT;
	["TossFlag"] = BT_TOSSFLAG;
	["FireNormal"] = BT_FIRENORMAL;
	["Custom1"] = BT_CUSTOM1;
	["Custom2"] = BT_CUSTOM2;
	["Custom3"] = BT_CUSTOM3;
}

function _Gem:Energy(mo, amount)
	if mo and mo.valid then
		if mo.geminfo then
			mo.geminfo.energy = min(max(0, mo.geminfo.energy + amount), mo.geminfo.maxenergy + mo.geminfo.bonusenergy)
		end
	end
end

function _Gem:DelayCharge(mo, amount)
	if mo and mo.valid then
		if mo.geminfo then
			mo.geminfo.rechargedelay = amount
		end
	end
end

addHook("PlayerThink", function(player)
	local mo = player.mo
	if player.gemdata == nil then
		player.gemdata = {}
		player.gemdata.enabled = false
		player.gemdata.input = BT_CUSTOM3
		player.gemdata.nextdown = false
		player.gemdata.prevdown = false
		player.gemdata.hidehud = false
	end
	if not (mo and mo.valid) then
		return
	end
	if player.mo.geminfo == nil then
		player.mo.geminfo = {}
		player.mo.geminfo.moveset = "Gem Shoes"
		player.mo.geminfo.energy = _Gem.Max_Energy
		player.mo.geminfo.maxenergy = _Gem.Max_Energy
		player.mo.geminfo.bonusenergy = 0
		player.mo.geminfo.recharge = _Gem.Recharge_Rate
		player.mo.geminfo.rechargedelay = 0
		player.mo.geminfo.selection = 1
		player.mo.geminfo.selectable = true
		player.mo.geminfo.text = ""
		player.mo.geminfo.inputdown = false
	end
	local data = player.gemdata
	local gem = mo.geminfo
	
	if not (player.cmd.buttons & BT_TOSSFLAG) and data.enabled and player.mo.geminfo.selectable then
		local weaponMask = (player.cmd.buttons & BT_WEAPONMASK)
		if weaponMask >= 1 and weaponMask <= 7 then
			if player.mo.geminfo.selection ~= weaponMask then
				player.mo.geminfo.selection = weaponMask
			end
		end
		
		if (player.cmd.buttons & BT_WEAPONNEXT) and not data.nextdown then
			data.nextdown = true
			player.mo.geminfo.selection = player.mo.geminfo.selection + 1
			if player.mo.geminfo.selection > 7 then
				player.mo.geminfo.selection = 1
			end
		elseif not (player.cmd.buttons & BT_WEAPONNEXT) then
			data.nextdown = false
		end
		
		if (player.cmd.buttons & BT_WEAPONPREV) and not data.prevdown then
			data.prevdown = true
			player.mo.geminfo.selection = player.mo.geminfo.selection - 1
			if player.mo.geminfo.selection < 1 then
				player.mo.geminfo.selection = 7
			end
		elseif not (player.cmd.buttons & BT_WEAPONPREV) then
			data.prevdown = false
		end
	end
	
	if (player.cmd.buttons & data.input) and data.enabled then
		gem.inputdown = true
	else
		gem.inputdown = false
	end
	
	if gem.rechargedelay <= 0 then
		local Rate = _Gem.Recharge_Rate * ((player.powers[pw_super] > 0 and 2) or 1)
		gem.energy = min(gem.energy + Rate, gem.maxenergy + gem.bonusenergy)
	else
		gem.rechargedelay = $ - 1
	end
	if player.powers[pw_super] > 0 then
		gem.bonusenergy = 500
	else
		gem.bonusenergy = 0
	end
end)

addHook("ThinkFrame", function(player)
	GameTick = $ + 1
end)

COM_AddCommand("gems", function(player, argument)
	if player.gemdata then
		player.gemdata.enabled = not player.gemdata.enabled
		local message = (player.gemdata.enabled and "Gem Abilities enabled!") or "Gem Abilities disabled!"
		CONS_Printf(player, "\x84" .. message)
	end
end, 0)

COM_AddCommand("gemsbind", function(player, argument)
	if player.gemdata then
		local Bound = nil
		for i,v in pairs(_Gem.Binds) do
			if string.lower(i) == string.lower(argument or "") then
				Bound = i
				player.gemdata.input = v
				break
			end
		end
		if not Bound then
			CONS_Printf(player, "List of all available binds:")
			for i,v in pairs(_Gem.Binds) do
				CONS_Printf(player, " - " .. i)
			end
		else
			CONS_Printf(player, "Bound successfully to " .. Bound .. "!")
		end
	end
end, 0)

COM_AddCommand("maxlvl", function(player, argument)
	if player.gemdata and player.gemdata then
		for i,v in pairs(player.gemdata.levels) do
			v.level = 3
			v.xp = 0
			v.xptonext = 4
		end
	end
end, COM_ADMIN)