// Alien Crime Lord

freeslot("S_PLAY_HS_START", "S_PLAY_HS_SEARCH", "S_PLAY_HS_TRACK", "S_PLAY_HS_END")

states[S_PLAY_HS_START] = {
	sprite = SPR_PLAY;
	frame = SPR2_JUMP|FF_ANIMATE;
	tics = 7;
	action = nil;
	var1 = 6;
	var2 = 2;
	nextstate = S_PLAY_HS_SEARCH
}

states[S_PLAY_HS_SEARCH] = {
	sprite = SPR_PLAY;
	frame = SPR2_JUMP|FF_ANIMATE;
	tics = 3;
	action = nil;
	var1 = 6;
	var2 = 2;
	nextstate = S_PLAY_HS_END
}

states[S_PLAY_HS_TRACK] = {
	sprite = SPR_PLAY;
	frame = SPR2_JUMP;
	tics = 1;
	action = A_HomingChase;
	var1 = 100*FRACUNIT;
	var2 = 1;
	nextstate = S_PLAY_HS_TRACK;
}

states[S_PLAY_HS_END] = {
	sprite = SPR_PLAY;
	frame = SPR2_FALL;
	tics = 15;
	action = nil;
	var1 = 0;
	var2 = 0;
	nextstate = S_PLAY_JUMP;
}

freeslot("S_HS_LOCKON")
states[S_HS_LOCKON] = {
	sprite = SPR_LCKN;
	frame = FF_FULLBRIGHT;
	tics = 2;
	action = nil;
	var1 = nil;
	var2 = nil;
	nextstate = S_NULL
}

freeslot("S_PLAY_TORNADO_SPIN", "S_PLAY_TORNADO_END")
states[S_PLAY_TORNADO_SPIN] = {
	sprite = SPR_PLAY;
	frame = SPR2_SPNG;
	tics = 1;
	action = nil;
	var1 = 0;
	var2 = 0;
	nextstate = S_PLAY_TORNADO_SPIN
}

states[S_PLAY_TORNADO_END] = {
	sprite = SPR_PLAY;
	frame = SPR2_FALL;
	tics = 90;
	action = nil;
	var1 = 0;
	var2 = 0;
	nextstate = S_PLAY_FALL
}

freeslot("MT_TORNADODUST", "S_TORNADO_DUST", "SPR_TGDZ")
states[S_TORNADO_DUST] = {
	sprite = SPR_TGDZ;
	frame = A|FF_TRANS30|FF_FULLBRIGHT;
	tics = 35;
	action = nil;
	var1 = 0;
	var2 = 0;
	nextstate = S_NULL
}

mobjinfo[MT_TORNADODUST] = {
	spawnstate = S_TORNADO_DUST,
	spawnhealth = 1,
	radius = 5*FRACUNIT,
	height = 5*FRACUNIT,
	speed = 0,
	damage = nil,
	deathsound = nil,
	deathstate = nil,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY
}

freeslot("MT_SKYGEMTP", "S_SKYGEM", "S_SKYGEM_END", "SPR_SKGM")
function A_SkyGemTeleport(skygem, var1, var2)
	if skygem and skygem.valid then
		if skygem.fuse <= 1 then
			return
		end
	end
	local mo = skygem.thrower
	if mo and mo.valid then
		if mo.player and mo.player.valid then
			if mo.player.gemdata and mo.geminfo then
				local data = mo.player.gemdata
				local gem = mo.geminfo
				
				gem.gundrive.gem = nil
				P_TeleportMove(mo, skygem.x, skygem.y, skygem.z)
				
				S_StartSound(mo, sfx_s3kb3)
				//P_FlashPal(mo.player, 2, 10)
				
				gem.selectable = true
			end
		end
	end
end

states[S_SKYGEM] = {
	sprite = SPR_SKGM;
	frame = A|FF_FULLBRIGHT;
	tics = 6;
	action = nil;
	var1 = 0;
	var2 = 0;
	nextstate = S_SKYGEM
}

states[S_SKYGEM_END] = {
	sprite = SPR_SKGM;
	frame = A|FF_FULLBRIGHT;
	tics = 1;
	action = A_SkyGemTeleport;
	var1 = 0;
	var2 = 0;
	nextstate = S_NULL
}

mobjinfo[MT_SKYGEMTP] = {
	spawnstate = S_SKYGEM,
	raisestate = nil,
	spawnhealth = 100,
	seesound = nil,
	attacksound = nil,
	height = 25*FRACUNIT,
	radius = 25*FRACUNIT,
	damage = 0,
	speed = 80*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY,
	deathstate = S_SKYGEM_END,
	xdeathstate = S_SKYGEM_END,
	deathsound = nil,
}

addHook("MobjThinker", function(skygem)
	if skygem and skygem.valid then
		if not skygem.rotateangle then
			skygem.rotateangle = P_RandomRange(-4,4)*FRACUNIT
		end
		if not skygem.lifetime then
			skygem.lifetime = 0
		end
		skygem.lifetime = $ + 1
		if skygem.lifetime > 2 then
			skygem.flags = $ & ~MF_NOGRAVITY
		end
		skygem.rollangle = $ + skygem.rotateangle
		
		local trail = P_SpawnGhostMobj(skygem)
		trail.fuse = 8
	end
end, MT_SKYGEMTP)

addHook("ShouldDamage", function(target, inflictor)
	if target and target.valid and inflictor and inflictor.valid and inflictor.type == MT_SKYGEMTP then
		return false
	end
end)