// Alien Crime Lord

local TextData = {
	[1] = "\x83Tornado";
	[2] = "\x85Slow";
	[3] = "\x84Mach Speed";
	[4] = "\x80Homing Smash";
	[5] = "\x88Gun Drive";
	[6] = "\x82Thunder Guard";
	[7] = "\x89Scale";
}

local IsSlow = false
local Slow = {}
local SlowCanThink = false
local SlowNextThink = 0

local NoHoming = {
	MT_BOXSPARKLE;
	MT_RING_BOX;
	MT_PITY_BOX;
	MT_ATTRACT_BOX;
	MT_FORCE_BOX;
	MT_ARMAGEDDON_BOX;
	MT_WHIRLWIND_BOX;
	MT_ELEMENTAL_BOX;
	MT_SNEAKERS_BOX;
	MT_INVULN_BOX;
	MT_1UP_BOX;
	MT_EGGMAN_BOX;
	MT_MIXUP_BOX;
	MT_MYSTERY_BOX;
	MT_GRAVITY_BOX;
	MT_RECYCLER_BOX;
	MT_SCORE1K_BOX;
	MT_SCORE10K_BOX;
	MT_FLAMEAURA_BOX;
	MT_BUBBLEWRAP_BOX;
	MT_THUNDERCOIN_BOX;
	MT_PITY_GOLDBOX;
	MT_ATTRACT_GOLDBOX;
	MT_FORCE_GOLDBOX;
	MT_ARMAGEDDON_GOLDBOX;
	MT_WHIRLWIND_GOLDBOX;
	MT_ELEMENTAL_GOLDBOX;
	MT_SNEAKERS_GOLDBOX;
	MT_INVULN_GOLDBOX;
	MT_EGGMAN_GOLDBOX;
	MT_GRAVITY_GOLDBOX;
	MT_FLAMEAURA_GOLDBOX;
	MT_BUBBLEWRAP_GOLDBOX;
	MT_THUNDERCOIN_GOLDBOX;
	MT_RING_REDBOX;
	MT_RING_BLUEBOX;
	MT_YELLOWSPRING;
	MT_REDSPRING;
	MT_BLUESPRING;
	MT_YELLOWDIAG;
	MT_REDDIAG;
	MT_BLUEDIAG;
	MT_YELLOWHORIZ;
	MT_REDHORIZ;
	MT_BLUEHORIZ;
	MT_BOOSTERSEG;
	MT_BOOSTERROLLER;
	MT_YELLOWBOOSTER;
	MT_REDBOOSTER;
}

local function Unscale(player)
	local mo = player.mo
	local gem = mo.geminfo
	mo.destscale = gem.scale.oldscale
	player.jumpfactor = skins[mo.skin].jumpfactor
	player.camerascale = skins[mo.skin].camerascale
	gem.scale.enabled = false
	gem.selectable = true
end

local function IsActionable(mo)
	if ACL:IsActionable(mo) then
		return true
	end
	return false
end

addHook("ThinkFrame", function()
	for player in players.iterate do
		local data = player.gemdata
		local mo = player.mo
		if mo and mo.valid and data and mo.geminfo then
			local gem = mo.geminfo
			
			if not data.levels then
				data.levels = {}
				for i = 1, 7 do
					table.insert(data.levels, {level = 1, xp = 0, xptonext = 3})
				end
			end
			if not gem.ginput then
				gem.ginput = false
			end
			
			if data.levels[gem.selection] then
				local info = data.levels[gem.selection]
				if info.xp >= info.xptonext and info.level < 3 then
					if info.level == 1 then
						info.level = 2
						info.xp = 0
						info.xptonext = 3
						S_StartSound(mo, sfx_token, player)
					elseif info.level == 2 then
						info.level = 3
						info.xp = 0
						info.xptonext = 0
						S_StartSound(mo, sfx_token, player)
					end
				end
			end
			
			if not gem.tornado then
				gem.tornado = {}
				gem.tornado.ground = nil
				gem.tornado.timer = 0
				gem.tornado.angle = 0
				gem.tornado.x = 0
				gem.tornado.y = 0
				gem.tornado.z = 0
			end
			if not gem.slow then
				gem.slow = {}
				gem.slow.enabled = false
			end
			if not gem.machspeed then
				gem.machspeed = {}
				gem.machspeed.timer = 0
			end
			if not gem.homingsmash then
				gem.homingsmash = {}
				gem.homingsmash.timer = 0
				gem.homingsmash.state = ""
				gem.homingsmash.target = nil
			end
			if not gem.gundrive then
				gem.gundrive = {}
				gem.gundrive.isthrowing = false
				gem.gundrive.gem = nil
			end
			if not gem.thundershield then
				gem.thundershield = {}
				gem.thundershield.enabled = false
			end
			if not gem.scale then
				gem.scale = {}
				gem.scale.enabled = false
				gem.scale.oldscale = mo.scale
			end
			
			if gem.moveset == "Gem Shoes" then
				// Input
				if gem.inputdown and not gem.ginput and data.enabled then
					gem.ginput = true
					// Tornado
					if gem.selection == 1 then
						local levelinfo = data.levels[1]
						local consumpation = (levelinfo.level == 1 and 400) or (levelinfo.level == 2 and 300) or 200
						if gem.energy >= consumpation and gem.tornado.timer <= 0 and IsActionable(mo) then
							gem.tornado.x = mo.x
							gem.tornado.y = mo.y
							gem.tornado.z = mo.z
							gem.tornado.timer = 360
							gem.tornado.angle = mo.angle
							gem.tornado.ground = P_IsObjectOnGround(mo)
							mo.state = S_PLAY_TORNADO_SPIN
							S_StartSound(mo, sfx_wdjump)
							S_StartSound(mo, sfx_s3k97)
							_Gem:Energy(mo, -consumpation)
							_Gem:DelayCharge(mo, 35)
						end
					end
					// Slow
					if gem.selection == 2 then
						local levelinfo = data.levels[2]
						local consumpation = (levelinfo.level == 1 and 10) or (levelinfo.level == 2 and 6) or 2
						if gem.energy > consumpation then
							gem.slow.enabled = true
							gem.selectable = false
							S_StartSound(mo, sfx_mswarp)
						end
					end
					// Mach Speed
					if gem.selection == 3 then
						local levelinfo = data.levels[3]
						local consumpation = (levelinfo.level == 1 and 250) or (levelinfo.level == 2 and 185) or 150
						if gem.energy >= consumpation and gem.machspeed.timer <= -20 and P_IsObjectOnGround(mo) and IsActionable(mo) then
							gem.machspeed.timer = 10
							gem.machspeed.angle = mo.angle
							S_StartSound(mo, sfx_zoom)
							S_StartSound(mo, sfx_kc4d)
							_Gem:Energy(mo, -consumpation)
							_Gem:DelayCharge(mo, 35)
							if player.charflags & SF_DASHMODE then
								mo.state = S_PLAY_DASH
							else
								mo.state = S_PLAY_RUN
							end
						end
					end
					// Homing Smash
					if gem.selection == 4 then
						local levelinfo = data.levels[4]
						local consumpation = (levelinfo.level == 1 and 250) or (levelinfo.level == 2 and 125) or 50
						if gem.energy >= consumpation and not P_IsObjectOnGround(mo) and gem.homingsmash.timer <= 0 and gem.homingsmash.target and IsActionable(mo) then
							gem.homingsmash.timer = 20
							mo.state = S_PLAY_HS_START
							S_StartSound(mo, sfx_mswarp)
						end
					end
					// Gun Drive
					if gem.selection == 5 then
						local levelinfo = data.levels[4]
						local consumpation = (levelinfo.level == 1 and 350) or (levelinfo.level == 2 and 250) or 150
						if not (gem.gundrive.gem and gem.gundrive.gemvalid) and not gem.gundrive.isthrowing then
							if gem.energy >= consumpation and IsActionable(mo) then
								local skygem = P_SPMAngle(mo, MT_SKYGEMTP, mo.angle, 1)
								if skygem then
									skygem.thrower = mo
									gem.gundrive.gem = skygem
									gem.selectable = false
									gem.gundrive.isthrowing = true
									if levelinfo.level <= 1 then
										skygem.fuse = 50
									elseif levelinfo.level == 2 then
										skygem.fuse = 100
									elseif levelinfo.level >= 3 then
										skygem.fuse = 200
									end
									S_StartSound(mo, sfx_wepfir)
									_Gem:Energy(mo, -consumpation)
									_Gem:DelayCharge(mo, 35)
								end
							end
						end
					end
					// Thunder Guard
					if gem.selection == 6 then
						if not gem.thundershield.enabled then
							local levelinfo = data.levels[6]
							local consumpation = (levelinfo.level == 1 and 150) or (levelinfo.level == 2 and 105) or 75
							if player.powers[pw_shield] <= 0 and gem.energy >= consumpation then
								local levelinfo = data.levels[6]
								P_SwitchShield(player, SH_ATTRACT)
								gem.thundershield.enabled = true
								gem.selectable = false
								player.powers[pw_shield] = SH_ATTRACT
								_Gem:Energy(mo, -consumpation)
								_Gem:DelayCharge(mo, 35)
								S_StartSound(mo, sfx_attrsg)
							end
						else
							gem.thundershield.enabled = false
							gem.selectable = true
							P_RemoveShield(player)
						end
					end
					// Scale
					if gem.selection == 7 then
						local levelinfo = data.levels[7]
						local consumpation = (levelinfo.level == 1 and 150) or (levelinfo.level == 2 and 105) or 75
						if not gem.scale.enabled and gem.energy >= consumpation then
							gem.scale.enabled = true
							mo.destscale = FixedDiv(mo.scale, 2*FRACUNIT)
							S_StartSound(mo, sfx_kc65)
							player.camerascale = FixedMul(player.camerascale, 2*FRACUNIT)
							gem.selectable = false
						elseif gem.scale.enabled then
							gem.scale.enabled = false
							gem.selectable = true
							Unscale(player)
						end
					end
				elseif not gem.inputdown and gem.ginput then
					gem.ginput = false
					if gem.slow.enabled then
						gem.slow.enabled = false
						gem.selectable = true
						//S_StopSoundByID(mo, sfx_slowfx)
					end
				end
				
				// Hud
				local levelinfo = data.levels[gem.selection]
				gem.text = TextData[gem.selection]
				gem.text3 = "Level " .. tostring(levelinfo.level)
				if levelinfo.level < 3 then
					gem.text3 = gem.text3 .. " (" .. tostring(levelinfo.xp) .. "/" .. tostring(levelinfo.xptonext) .. ")"
				end
			else
				gem.ginput = false
				gem.thundershield.enabled = false
				gem.selectable = true
				gem.scale.enabled = false
				if gem.slow.enabled then
					gem.slow.enabled = false
					//S_StopSoundByID(mo, sfx_slowfx)
				end
			end
			
			// Abilities
			// Tornado
			if gem.tornado.timer > 0 then
				if mo.state == S_PLAY_TORNADO_SPIN then
					//gem.tornado.angle = $ + FixedAngle(gem.tornado.timer*FRACUNIT)
					player.drawangle = gem.tornado.angle + FixedAngle(gem.tornado.timer*FRACUNIT)
					mo.momx = 0
					mo.momy = 0
					P_SetObjectMomZ(mo, 8*FRACUNIT)
					if gem.tornado.timer == 0 or gem.tornado.timer == 180 or gem.tornado.timer == 360 then
						P_RadiusAttack(mo, mo, 512*FRACUNIT, 1, true)
					end
					
					local trail = P_SpawnGhostMobj(mo)
					trail.fuse = 8
					trail.sprite2 = trail.sprite2|FF_FULLBRIGHT
					trail.color = SKINCOLOR_GREEN
					trail.colorized = true 
					
					for i = -8, 4 do
						local dust = P_SpawnMobj(gem.tornado.x, gem.tornado.y, gem.tornado.z - (10*FRACUNIT), MT_TORNADODUST)
						dust.fuse = 20
						dust.scale = $ * 2
						dust.angle = player.drawangle + (FixedAngle((30*i)*FRACUNIT))
						dust.color = SKINCOLOR_AETHER
						dust.rollangle = FixedAngle(P_RandomRange(1,360)*FRACUNIT)
					end
				end
				gem.tornado.timer = max(gem.tornado.timer - 28, 0)
				if not IsActionable(mo) then
					gem.tornado.timer = 0
				end
				if gem.tornado.timer <= 0 then
					mo.state = S_PLAY_TORNADO_END
					if gem.tornado.ground then
						P_SetObjectMomZ(mo, 20*FRACUNIT)
					else
						P_SetObjectMomZ(mo, 12*FRACUNIT)
					end
					gem.selectable = true
				else
					gem.selectable = false
				end
			end
			// Slow
			if IsSlow and gem.slow.enabled then
				local trail = P_SpawnGhostMobj(mo)
				trail.fuse = 12
				trail.sprite2 = trail.sprite2|FF_FULLBRIGHT
				trail.color = SKINCOLOR_RED
				trail.colorized = true 
				if player.speed > 3*FRACUNIT then
					trail.fuse = 12
				else
					trail.fuse = 2
				end
			end
			if gem.slow.enabled then
				local levelinfo = data.levels[2]
				local consumpation = (levelinfo.level == 1 and 10) or (levelinfo.level == 2 and 6) or 2
				_Gem:Energy(mo, -consumpation)
				_Gem:DelayCharge(mo, 35)
				gem.selectable = false
				if gem.energy <= 0 then
					gem.slow.enabled = false
					gem.selectable = true
					//S_StopSoundByID(mo, sfx_slowfx)
				end
			end
			
			// Mach Speed
			if gem.machspeed.timer > -20 then
				gem.machspeed.timer = $ - 1
				if gem.machspeed.timer > 0 then
					local speed = (mo.eflags & MFE_UNDERWATER and 45*FRACUNIT) or 95*FRACUNIT
					P_InstaThrust(mo, mo.angle, FixedMul(speed, mo.scale))
					local trail = P_SpawnGhostMobj(mo)
					trail.fuse = 10
					trail.sprite2 = trail.sprite2|FF_FULLBRIGHT
					trail.color = SKINCOLOR_ICY
					trail.colorized = true
					mo.colorized = (gem.machspeed.timer > 1 and true) or false
					player.drawangle = mo.angle
					if player.charflags & SF_DASHMODE then
						//player.dashmode = TICRATE*3
					end
					gem.selectable = false
					if P_IsObjectOnGround(mo) then
						if player.charflags & SF_DASHMODE then
							mo.state = S_PLAY_DASH
						else
							mo.state = S_PLAY_RUN
						end
						player.pflags = $ & ~PF_SPINNING
					end
					player.pflags = $|PF_JUMPSTASIS
				elseif gem.machspeed.timer <= 0 then
					gem.selectable = true
					if gem.machspeed.timer > -2 then
						if not P_IsObjectOnGround(mo) then
							if player.speed > (player.normalspeed + 4*FRACUNIT) then
								P_InstaThrust(mo,mo.angle,FixedMul((player.normalspeed + 4*FRACUNIT), mo.scale))
							end
						end
					end
				end
			end
			
			// Homing Smash
			if gem.selection == 4 and not P_IsObjectOnGround(mo) then
				local target = P_LookForEnemies(player, false, true) or P_LookForEnemies(player, false, false) or nil
				if target and target.valid and not ACL:InTable(NoHoming, target.type) then
					gem.homingsmash.target = target
					P_SpawnLockOn(player, target, S_HS_LOCKON)
				else
					gem.homingsmash.target = nil
				end
			end
			if gem.homingsmash.timer > 0 then
				if P_IsObjectOnGround(mo) and (mo.state ~= S_PLAY_HS_SEARCH or mo.state ~= S_PLAY_HS_TRACK) then
					mo.state = (mo.tracer and mo.tracer.valid and S_PLAY_HS_TRACK) or S_PLAY_HS_SEARCH
				end
				if mo.state == S_PLAY_HS_START then
					gem.selectable = false
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
					local trail = P_SpawnMobjFromMobj(mo,0,0,-7*FRACUNIT,MT_THOK)
					trail.state = S_THOK
					trail.fuse = 2
					trail.sprite2 = trail.sprite2|FF_FULLBRIGHT
					trail.color = SKINCOLOR_WHITE
					//trail.colorized = true
				elseif mo.state == S_PLAY_HS_SEARCH and not (mo.tracer and mo.tracer.valid) then
					local target = gem.homingsmash.target
					if target and target.valid then
						mo.tracer = target
						mo.state = S_PLAY_HS_TRACK
						S_StartSound(mo, sfx_thok)
						gem.homingsmash.timer = 20
						local levelinfo = data.levels[4]
						local consumpation = (levelinfo.level == 1 and 250) or (levelinfo.level == 2 and 125) or 50
						_Gem:Energy(mo, -consumpation)
						_Gem:DelayCharge(mo, 35)
					else
						mo.tracer = nil
						gem.homingsmash.timer = 0
					end
					player.pflags = $ & ~PF_NOJUMPDAMAGE
				elseif mo.state == S_PLAY_HS_TRACK then
					local trail = P_SpawnMobjFromMobj(mo,0,0,-7*FRACUNIT,MT_THOK)
					trail.state = S_THOK
					trail.fuse = 16
					trail.sprite2 = trail.sprite2|FF_FULLBRIGHT
					trail.color = SKINCOLOR_WHITE
					trail.destscale = 0
					//trail.colorized = true
					player.pflags = $ & ~PF_NOJUMPDAMAGE
				elseif mo.state == S_PLAY_HS_END
					gem.homingsmash.timer = 0
					gem.selectable = true
					mo.tracer = nil
				end
				local levelinfo = data.levels[4]
				if not IsActionable(mo) or gem.energy <= 0 then
					gem.homingsmash.timer = 0
					gem.selectable = true
					P_InstaThrust(mo, mo.angle, FixedMul(15*FRACUNIT, mo.scale))
					mo.tracer = nil
				end
				gem.homingsmash.timer = max(gem.homingsmash.timer - 1, 0)
				if gem.homingsmash.timer <= 0 then
					gem.selectable = true
				end
			end
			// Gun Drive
			if gem.gundrive.isthrowing then
				if (gem.gundrive.gem and gem.gundrive.gem.valid) then
					local trail = P_SpawnGhostMobj(mo)
					trail.sprite2 = trail.sprite2|FF_FULLBRIGHT
					trail.color = SKINCOLOR_CYAN
					trail.colorized = true 
					trail.fuse = 2
				else
					gem.gundrive.isthrowing = false
					gem.selectable = true
				end
			end
			
			// Thunder Guard
			if gem.thundershield.enabled then
				local levelinfo = data.levels[6]
				if player.powers[pw_shield] == SH_ATTRACT then
					if levelinfo.level < 3 then
						_Gem:Energy(mo, (levelinfo.level == 1 and -5) or -3)
					end
					_Gem:DelayCharge(mo, 35)
					if gem.energy <= 0 then
						P_RemoveShield(player)
						gem.thundershield.enabled = false
						gem.selectable = true
					end
				else
					gem.selectable = true
					gem.thundershield.enabled = false
				end
			end
			
			// Scale
			if gem.scale.enabled then
				local levelinfo = data.levels[7]
				if mo.scale ~= mo.destscale then
					local trail = P_SpawnGhostMobj(mo)
					trail.fuse = 8
					trail.sprite2 = trail.sprite2|FF_FULLBRIGHT
					trail.color = SKINCOLOR_MAGENTA
					trail.colorized = true
				else
					local trail = P_SpawnGhostMobj(mo)
					trail.fuse = 2
					trail.sprite2 = trail.sprite2|FF_FULLBRIGHT
					trail.color = SKINCOLOR_MAGENTA
					trail.colorized = true 
					if player.jumpfactor == skins[mo.skin].jumpfactor then
						local level1 = 2*FRACUNIT
						local level2 = FixedDiv(5*FRACUNIT, 2*FRACUNIT)
						local level3 = 3*FRACUNIT
						player.jumpfactor = FixedMul(player.jumpfactor, ((levelinfo.level == 1 and level1) or (levelinfo.level == 2 and level2) or level3))
					end
				end
				local consumpation = (levelinfo.level == 1 and 4) or (levelinfo.level == 2 and 3) or 2
				_Gem:Energy(mo, -consumpation)
				_Gem:DelayCharge(mo, 35)
				gem.selectable = false
				if gem.energy <= 0 then
					Unscale(player)
					gem.selectable = true
					gem.scale.enabled = false
				end
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.gemdata and player.mo and player.mo.valid and player.mo.geminfo then
		local mo = player.mo
		local gem = mo.geminfo
		local data = player.gemdata
		if gem.gundrive.enabled
		or gem.machspeed.timer > 0
		or gem.homingsmash.timer > 0
		or gem.tornado.timer > 0 then
			return true
		end
	end
end)

// Tornado Effect
addHook("MobjThinker", function(dust)
	if dust and dust.valid then
		if dust.lifetime == nil then
			dust.lifetime = 0
		end
		if not ring then
			if dust.lifetime == 0 then
				P_InstaThrust(dust, dust.angle, 50*FRACUNIT)
			else
				P_InstaThrust(dust, dust.angle, 5*FRACUNIT)
			end
			P_SetObjectMomZ(dust, 15*FRACUNIT)
		else
			if dust.lifetime == 0 then
				P_InstaThrust(dust,dust.angle, 80*FRACUNIT)
			end
			P_SetObjectMomZ(dust, 10*FRACUNIT)
		end
		dust.lifetime = $ + 1
	end
end, MT_TORNADODUST)

// Red Gem Slow
addHook("PostThinkFrame", function()
	local Active = false
	for player in players.iterate do
		if player.mo and player.mo.valid then
			if Active == false then
				if player.mo.geminfo then
					if player.mo.geminfo.slow.enabled then
						Active = true
					end
				end
			end
		end
	end
	IsSlow = Active
	if IsSlow then
		local Time = 3
		local SlowTime = -1
		SlowNextThink = min(SlowNextThink + 1, Time)
		if SlowNextThink >= Time then
			SlowNextThink = SlowTime
		end
		SlowCanThink = (SlowNextThink < 0 and true) or false
	end
end)

addHook("MobjThinker", function(mo)
	if mo.valid then
		if mo.flags & (MF_ENEMY|MF_BOSS|MF_MISSILE) and IsSlow then
			if not SlowCanThink then
				return true
			end
		end
	end
end)

local function SlowThinker(mo)
	if mo.valid then
		if IsSlow and not SlowCanThink then
			return true
		end
	end
end

for i,v in pairs(TI_Inclusion) do
	addHook("MobjThinker", SlowThinker, v)
end
for i,v in pairs(TI_Flickies) do
	addHook("MobjThinker", SlowThinker, v)
end

// Homing Smash
local function CheckCollision(target, mo, hook)
	if target and target.valid and mo and mo.valid and ACL:CheckHeight(target,mo) then
		local player = mo.player
		
		if not player or not player.valid then
			return
		end
		
		local gem = mo.geminfo
		local data = player.gemdata
		if not gem or not data then
			return
		end
		
		if gem.machspeed.timer > 0 then
			if not hook and target.valid and target.health > 0 then
				pcall(P_DamageMobj, target, mo, mo, 1) // sometimes it randomly sends C errors into the console, so here's a cheap fix
			end
		end
		if gem.homingsmash.timer > 0 and mo.state == S_PLAY_HS_TRACK then
			P_InstaThrust(mo, mo.angle, FixedMul(15*FRACUNIT, mo.scale))
			P_SetObjectMomZ(mo, 10*FRACUNIT)
			mo.state = S_PLAY_HS_SEARCH
			mo.tracer = nil
			gem.homingsmash.timer = 20
			if not hook and target.valid and target.health > 0 then
				pcall(P_DamageMobj, target, mo, mo, 1) // sometimes it randomly sends C errors into the console, so here's a cheap fix
			end
		end
	end
end

local function Collision(target, mo)
	if target and target.valid and mo and mo.valid then
		if target.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) then
			return CheckCollision(target, mo)
		end
	end
end

addHook("MobjCollide", Collision)
addHook("MobjMoveCollide", Collision)
addHook("MobjDamage", function(target, mo)
	if mo and mo.valid and mo.player and mo.geminfo and mo.geminfo.homingsmash.timer > 0 then
		CheckCollision(target, mo, true)
		//return true
	end
end)
addHook("MobjDeath", CheckCollision)

addHook("ShouldDamage", function(target, inflictor)
	if target and inflictor and target.valid and inflictor.valid then
		if target.player and target.geminfo then
			if target.geminfo.homingsmash.timer > 0 then
				return false
			end
		end
	end
end, MT_PLAYER)

// Thunder Shield
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid then
		if target.geminfo then
			local gem = target.geminfo
			if gem.thundershield.enabled then
				S_StartSound(mo, sfx_cdfm03)
				gem.thundershield.enabled = false
				if target.player and target.player.valid then
					P_RemoveShield(target.player)
					gem.selectable = true
					target.player.powers[pw_flashing] = 35
				end
				return true
			end
			if gem.machspeed.timer > -10 then
				return true
			end
		end
	end
end, MT_PLAYER)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	// XP
	local inflictor = (inflictor and inflictor.valid and inflictor.player and inflictor) or source
	if target and target.valid and inflictor and inflictor.valid then
		if inflictor.geminfo then -- and inflictor.geminfo.moveset == "Gem Shoes" then
			if inflictor.player and inflictor.player.valid and inflictor.player.gemdata and inflictor.player.gemdata.levels and inflictor.player.gemdata.enabled then
				local gem = inflictor.geminfo
				local data = inflictor.player.gemdata
				local info = data.levels[gem.selection]
				if info.level then
					info.xp = info.xp + min(damage, target.health)
				end
			end
		end
	end
end)

// Clear Levels
addHook("MapChange", function()
	for player in players.iterate do
		if player.gemdata then
			local data = player.gemdata
			data.levels = {}
			for i = 1, 7 do
				table.insert(data.levels, {level = 1, xp = 0, xptonext = 3})
			end
		end
	end
end)